#!/bin/sh

cd `dirname $0`

SERV=`which rcssserver 2> /dev/null`
USE_MONITOR="false"
#USE_MONITOR="true"
SYNCH="true"

if [ "$USE_MONITOR" = "true" ]; then
MON=`which soccerwindow2-qt3 2> /dev/null`
if test $? -eq 1; then
  MON=`which soccerwindow2-qt4 2> /dev/null`
  if test $? -eq 1; then
    echo "Error: soccerwindow2 executable could not be found in your PATH."
    echo ""
    exit 1
  fi
fi
fi
MON=soccerwindow2
#--------------------------------------------------
# start server
# set server options here
#
serveropt=""

# synch mode
if [ "$SYNCH" = "true" ]; then
  serveropt="${serveropt} server::synch_mode = true"
fi

# log
#serveropt="${serveropt} server::text_logging = true"
#serveropt="${serveropt} server::game_logging = true"

# auto mode
serveropt="${serveropt} server::auto_mode = true"
serveropt="${serveropt} server::game_over_wait = 10"

# auto team
serveropt="${serveropt} server::team_l_start = '$PWD/lstart.sh'"
serveropt="${serveropt} server::team_r_start = '$PWD/../../agent2d/src/start.sh'"

# trainer
serveropt="${serveropt} server::coach = true"

# visible_angle
#serveropt="${serveropt} server::visible_angle = 540"

# full state
serveropt="${serveropt} server::fullstate_l = true"
serveropt="${serveropt} server::fullstate_r = true"

SERV="${SERV} ${serveropt}"


#--------------------------------------------------
# set monitor options here
#
monitoropt=""

monitoropt="${monitoropt} -c -d"
monitoropt="${monitoropt} --hide-stamina --hide-stamina-capacity"
monitoropt="${monitoropt} --hide-view-area"
monitoropt="${monitoropt} --hide-debug-view-comment"

MON="${MON} ${monitoropt}"

#--------------------------------------------------
# kill server
#
kill_server()
{
    kill -s INT $SERVER_PID
    echo ""
    exit 0
}

kill_monitor()
{
    kill $MONITOR_PID > /dev/null 2>&1
    echo ""
}

#---------------------------------------------------
# inf loop
#

if [ "$USE_MONITOR" = "true" ]; 
then
	$MON  > /dev/null 2>&1 &
	MONITOR_PID=$!
	$SERV
else
	$SERV
fi
