// -*-c++-*-

/*!
  \file player_config.cpp
  \brief player configuration Source File
*/

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "exp_config.h"

#include <rcsc/common/logger.h>
#include <rcsc/param/param_map.h>

#include <cassert>

/*-------------------------------------------------------------------*/
/*!

*/
ExpConfig::ExpConfig()
{
    setDefaultParam();
}

/*-------------------------------------------------------------------*/
/*!

*/
ExpConfig::~ExpConfig()
{

}

/*-------------------------------------------------------------------*/
/*!

*/
void
ExpConfig::setDefaultParam()
{
    M_log_dir = "";
    M_goal_log_name = "goal";
    
    M_finish_episode = 100;
}

/*-------------------------------------------------------------------*/
/*!

*/
void
ExpConfig::createParamMap( rcsc::ParamMap & param_map )
{
    param_map.add()
        ( "log_dir", "", &M_log_dir, "log file directory" )
        ( "goal_log_name", "", &M_goal_log_name, "goal log file name" )
        ( "finish_episode", "", &M_finish_episode, "episode to finish experiment" )
        ;
}

