#include "global_config.h"

#include <rcsc/param/param_map.h>
#include <rcsc/param/conf_file_parser.h>

#include <string>

//Хѿ
GlobalConfig gconfig;

ExpConfig
GlobalConfig::getExpConfig( const std::string & file_name )
{
    rcsc::ParamMap exp_param_map( "Experiment options" );
    ExpConfig exp;
    exp.createParamMap( exp_param_map );

    if( ! file_name.empty() ){
        rcsc::ConfFileParser conf_parser( file_name.c_str() );
        conf_parser.parse( exp_param_map );
    }

    return exp;
}

bool
GlobalConfig::isSameExpConfig( const std::string & file_name )
{
    if( M_exp == getExpConfig( file_name ) )
        return true;
    else
        return false;
}

LearnConfig
GlobalConfig::getLearnConfig( const std::string & file_name )
{
    rcsc::ParamMap learn_param_map( "Learning options" );
    LearnConfig learn;
    learn.createParamMap( learn_param_map );

    if( ! file_name.empty() ){
        rcsc::ConfFileParser conf_parser( file_name.c_str() );
        conf_parser.parse( learn_param_map );
    }

    return learn;
}

bool
GlobalConfig::isSameLearnConfig( const std::string & file_name )
{
    if( M_learn == getLearnConfig( file_name ) )
        return true;
    else
        return false;
}
