#ifndef STATE_H
#define STATE_H

#include "global.h"

#include <rcsc/player/world_model.h>
#include <rcsc/random.h>

const int STATE_NUM = 25;
const int CONSIDERABLE_NUM = 6;

class State
{ 
private:

    //the distances from O1 to its teammates(i=2,3,...,m)
    double M_dist_o1_o[CONSIDERABLE_NUM-1];

    //the distance from O1 to the goalie on the defense team
    double M_dist_o1_dg;

    //for the offense player, the distance to the segment of the GL
    //between the goalposts(i=1,2,...,m)
    double M_dist_o_gl[CONSIDERABLE_NUM];

    //for each offense player, the closest distance to any opponent
    //(i=1,2,...,m)
    double M_min_dist_o_d[CONSIDERABLE_NUM];

    //for offense player, the smallest angle OiO1D among all D
    //(i=2,3,...,m)
    double M_min_ang_o_o1_d[CONSIDERABLE_NUM-1];

    //the distance from O1 to the closest defender in the dribble cone
    double M_min_dist_o1_dcone;

    //the maximum angle near the goal;
    double M_max_goal_ang_o1;

    //֤μ
    int M_state_dim;

    //ƥѿ
    std::vector<double> M_array;

    //ξ֤λΥ
    int M_set_cycle;

public:
    
    State()
    :M_state_dim(4*CONSIDERABLE_NUM+1)
    {

    };

    ~State(){ };

    int dim() const
    {
        return M_state_dim;
    }

    int setCycle() const
    {
        return M_set_cycle;
    }

    double operator[](const int & idx);
    
    bool setState( const rcsc::WorldModel & wm);

    std::vector< double > getStateList() const
    {
        return M_array;
    }
    
//     std::vector< double > getStateList(const int & random_state_num,
//                                        const bool & additional_state) const
//     {
//         std::vector<double> vec = M_array;
//         rcsc::UniformReal uni_real(0,30);

//         for(int i=0; i<random_state_num; ++i){
//             vec.push_back( uni_real() );
//         }

//         if( additional_state ){
//             for(int i=0; i<ADDITIONAL_STATE_NUM; ++i){
//                 vec.push_back( M_additional[i] );
//             }
//         }
        
//         return vec;
//     }

    double distO1O(const int & idx) const
    {
        return M_dist_o1_o[idx];
    }

    double distO1Goalie() const
    {
        return M_dist_o1_dg;
    }


    double distOGoalLine(const int & idx) const
    {
        return M_dist_o_gl[idx];
    }

    double minDistOD(const int & idx) const
    {
        return M_min_dist_o_d[idx];
    }

    double minAngOO1D(const int & idx) const
    {
        return M_min_ang_o_o1_d[idx];
    }

    double minDistO1Dcone() const
    {
        return M_min_dist_o1_dcone;
    }

    double maxGoalAngO1() const
    {
        return M_max_goal_ang_o1;
    }
    
public:
    void test() const;

};

#endif
