#ifndef TILE_SARSA_H
#define TILE_SARSA_H

#include "action.h"
#include "state.h"
#include "rl_method.h"
#include <vector>
#include <map>
#include <iostream>
#include "tile_coding.h"

class TileSarsa
    : public RLMethod
{ 
private:

    const double M_epsilon;
    const double M_alpha;
    const int M_input_num;
    //ܤϤܤγؽ뤫
    const std::vector< std::vector<int> > M_input_map;
    const int M_tiling_num;
    const std::vector<double> M_tile_widths;
    const int M_tile_coding_num;  //1ưγؽ




        
    //ԥɤǽιɤ
    bool M_episode_first_call;

    //TileCoding饹
    std::vector< std::vector<TileCoding> > tc;

    //󹹿ξ
    State M_last_state;
    Action M_last_action;
    double M_last_Q;

public:

    void test()
    {
//        int act = static_cast<int>();
        for(unsigned int i=0; i<tc[4].size(); ++i){
                std::cout << "i = " << i << std::endl;
                tc[4][i].test();
        }
    }

    TileSarsa( const double &  epsilon,
               const double & alpha,
               const int & input_num,
               const std::vector< std::vector<int> > & input_map,
               const int & tile_num,
               const std::vector<double> & tile_widths );

    ~TileSarsa(){

    }

    void init()
    {
        M_episode_first_call = true;
    }

private:

    //---Ѿ۴ؿ---
    Action selectAction( const State & s );
    bool update( const State & s, Action a, const double & r );
    bool update( const double & r );
    bool readValue( const std::string & file_name );
    bool writeValue( const std::string & file_name );

    //---ʹϢ---
    double getValue( const State & s, Action a );
    bool updateValue( const State & s, Action a, const double & td_error );
    
};

#endif
