// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef AGENT2D_SAMPLE_PLAYER_H
#define AGENT2D_SAMPLE_PLAYER_H

#include <rcsc/player/player_agent.h>

#include "strategy.h"

#include <string>
#include "original/learn/rl_method.h"
#include "original/learn/state.h"
#include "original/learn/action.h"

class SamplePlayer
    : public rcsc::PlayerAgent {
private:

protected:
    Strategy M_strategy;

    RLMethod* M_rl_method;

    virtual void parseTrainerMessage( const std::string & message );
    virtual bool parseFreeformMessage( const std::string & message );

    bool doSelectedAction( Action a );

public:

    SamplePlayer();

    virtual
    ~SamplePlayer();

    void finalize();
    
    virtual
    void handleExit();

protected:

    /*!
      You can override this method.
      But you must call PlayerAgent::initImpl() in this method.
    */
    virtual
    bool initImpl( rcsc::CmdLineParser & cmd_parser );

    //! main decision
    virtual
    void actionImpl();

    //! communication decision
    virtual
    void communicationImpl();

    //! hook method for handling server param message
    virtual
    void handleServerParam();

private:

    bool sayBall();
    bool saySelf();
    bool sayGoalie();
    bool sayIntercept();
    bool sayOffsideLine();
    bool sayDefenseLine();

    void attentiontoSomeone();

    Action M_last_action;
    bool M_next_update;

public:
    void selectLearnAction();
};

#endif
